/*
------------------------------------------------------------
	contest.c - No, it means ConEmu Test! :-)
------------------------------------------------------------
 * Copyright (C) David Olofson, 2002
 *
 * This code is released under the terms of the GNU GPL.
 */

#include "conemu.h"

int main(int argc, char *argv [])
{
	int running, i;
	ce_window_t *win, *win2 = 0;

	if(ce_open(80, 25, CE_OPEN_ANYWHERE) < 0)
		return -1;

	win = ce_root_window();

	ce_printf(win, "Hello, dull world of text!\n\n");

	ce_bgcolor(win, CE_RED);
	ce_printf(win, "Gimme' an 'A'!\n");
	ce_bgcolor(win, CE_BLACK);
	while(1)
	{
		int c = ce_getc();
		if('A' == c)
			break;
		if('a' == c)
			ce_printf(win, "'A', not 'a'...\n");
	}
	ce_printf(win, "'A', as in what...!?\n\n");

	if(ce_kbhit() < 0)
		ce_printf(win, "Oops, no kbhit()...\n");
	else
	{
		ce_printf(win, "Waiting for the Any Key...");
		while(!ce_kbhit())
			ce_delay(10);
		ce_getc();
		ce_putchar(win, '\n');
	}

#if 0	/* Doesn't work yet... */
	win2 = ce_open_window(20, 10);
	if(!win2)
		ce_printf(win, "Oops, failed to open window...\n");
	else
	{
		ce_rect_t r;
		r.x = 50;
		r.y = 10;
		r.w = 25;
		r.h = 10;
		ce_move_window(win2, &r);
		ce_bgcolor(win2, CE_GREEN);
		ce_clear(win2);
		ce_printf(win2, "And here's another window!");
	}
#endif

	ce_clear(win);
	ce_printf(win, "Get ready for serious abuse...! >:-D\n");
	ce_delay(1000);
	i = 0;
	while(i < 5000)
		ce_putchar(win, 32 + (i++ & 63));
	ce_delay(1000);
	i = 25;
	while(i--)
		ce_putchar(win, '\n');

	if(win2)
		ce_close_window(win2);

	ce_clear(win);
	ce_printf(win, "Ok, now you may type away as you like.\n"
			"Hit Escape to quit.\n");

	running = 1;
	while(running)
	{
		int c = ce_getc();
		switch(c)
		{
		  case CE_LF:
		  case CE_CR:
			ce_putchar(win, '\n');
			break;
		  case CE_ESC:
			ce_clear(win);
			ce_printf(win, "\n  Bye!\n");
			ce_delay(1000);
			running = 0;
			break;
		  default:
			ce_putchar(win, c);
			break;
		}
	}

	ce_close();
	return 1;
}
